// TestDlg2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestDlg2.h"
#include "TestDlg2Dlg.h"
#include "AboutDlg.h"
#include <mmsystem.h>
#pragma comment (lib,"winmm.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// mapa ozvuceni
const int S_mapa[36] = 
{
	-1, -1, -1,  2,  2,  2,
	-1,  2, -1,  2,  2,  2,
	 2, -1, -1,  2,  2,  2,
	-1,  2,  2, -1, -1, -1,
	-1, -1, -1, -1, -1,  1,
	 0,  0,  0, -1,  1,  1,
};


UINT G_DBLCLKFunction( LPVOID pParam ) 
{
	srand((unsigned)time( NULL ));
	CTestDlg2Dlg *dl = (CTestDlg2Dlg *) pParam;

	int in = dl->GetIndex();

	PlaySound("WAV_HIT", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
	Sleep(250);

	if (in == dl->m_moucha) {
		dl->m_moucha = -1;
		if (dl->m_hits == 1) 
			PlaySound("WAV_ZASAH1", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
		else
			PlaySound("WAV_ZASAH", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
		dl->m_sounding = false;
		return 0;
	}
	
	if (S_mapa[in] != -1){
		CString s;
		s.Format("IDR_WAVE%d", S_mapa[in]+1);
		PlaySound(s, AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
	}

	Sleep(250);
	
	int dx = abs(in%6 - dl->m_moucha%6);
	int dy = abs(in/6 - dl->m_moucha/6);

	if (dx + dy == 1) 
		PlaySound("WAV_BLIZKO", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
	else
		if (dx == 1 && dy == 1)
			PlaySound("WAV_NEZASAH", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
		else
			PlaySound("WAV_NETREFILS", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);


	if (--(dl->m_tofly) <= 0) {
		Sleep(200);
		PlaySound("WAV_PRIC", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
		dl->m_moucha = rand()%36;
		dl->SetToFly();
	}

	dl->m_sounding = false;
	dl->SendMessage(WM_SETCURSOR);

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// CTestDlg2Dlg dialog

CTestDlg2Dlg::CTestDlg2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg2Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDlg2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg2Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg2Dlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg2Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_CTLCOLOR()
	ON_WM_ERASEBKGND()
	ON_WM_SETCURSOR()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_LBUTTONDBLCLK()
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	ON_WM_CLOSE()
	ON_COMMAND(ID_NASTAVENI_TEXT, OnNastaveniText)
	ON_COMMAND(ID_NASTAVENI_ZVUK, OnNastaveniZvuk)
	ON_UPDATE_COMMAND_UI(ID_NASTAVENI_TEXT, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_NASTAVENI_ZVUK, OnUpdate)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg2Dlg message handlers

BOOL CTestDlg2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_map = new CBitmap;
	m_map->LoadBitmap(IDB_GROUND);
	m_lbd = false;

	m_sounding = false;

	CRect r1, r2;
	GetWindowRect(r1);
	GetClientRect(r2);
	int w = 567 - r2.Width() + r1.Width(),
		 h = 624 - r2.Height() + r1.Height();

	SetWindowPos(NULL, 0, 0, w, h, SWP_NOMOVE | SWP_NOZORDER);


	
	SetWindowText("Chy tu mouchu!");
	

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_hCurP = AfxGetApp()->LoadCursor(IDC_PHAND);
	m_hCurS = AfxGetApp()->LoadCursor(IDC_PSMASH);
	

	m_zvuk = AfxGetApp()->GetProfileInt("Nastaveni", "zvuk", SZVUK);
	OnUpdate(NULL);

	// TODO: Add extra initialization here
	m_moucha = -1;
	
	SetTimer(0, 4000, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDlg2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDlg2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestDlg2Dlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_lbd = true;
	OnSetCursor(NULL, 0, 0);
/*
	CRect rect;
	GetWindowRect(&rect);

	if (point.x < 30 || point.y < 91 || point.x > 570 || point.y > 624) {
		SetCapture();
		m_mpoint = point;
	}

*/
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CTestDlg2Dlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
//	ReleaseCapture();
	m_lbd = false;
	OnSetCursor(NULL, 0, 0);

	CDialog::OnLButtonUp(nFlags, point);
}

void CTestDlg2Dlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_mouse = point;
/*	if (GetCapture()) {
		CRect rect;
		GetWindowRect(&rect);
		SetWindowPos(NULL, rect.left + point.x - m_mpoint.x, rect.top + point.y - m_mpoint.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
	}
*/	
	CDialog::OnMouseMove(nFlags, point);
}




HBRUSH CTestDlg2Dlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if (nCtlColor == CTLCOLOR_STATIC) {
	// TODO: Change any attributes of the DC here
		pDC->SetTextColor(RGB(255,255,255));
		pDC->SetBkMode(TRANSPARENT);


		LOGBRUSH lb;
		lb.lbStyle = BS_HOLLOW;
		CBrush brush;
		brush.CreateBrushIndirect(&lb);
//		brush.CreateSolidBrush(RGB(255,0,0));
		hbr = (HBRUSH) brush.Detach();
	}

	return hbr;
}

BOOL CTestDlg2Dlg::OnEraseBkgnd( CDC* pDC )
{
	CDialog::OnEraseBkgnd(pDC);

	CRect rect;
	GetWindowRect(&rect);
	rect.bottom -= rect.top; rect.top = 0;
	rect.right -= rect.left; rect.left = 0;

	pDC->FillSolidRect(rect, RGB(255,0,0));

	CDC  dc;
	dc.CreateCompatibleDC(pDC);
	CBitmap * p_dc = dc.SelectObject(m_map);
	pDC->BitBlt(0, 0, 600, 655, &dc, 0, 0, SRCCOPY);
	dc.SelectObject(p_dc);

	return TRUE;
}

BOOL CTestDlg2Dlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
/*	POINT pt;
	GetCursorPos(&pt);

	CRect rect;
	GetWindowRect(&rect);

	pt.x -= rect.left;
	pt.y -= rect.top;

	if (pt.x < 30 || pt.y < 91 || pt.x > 570 || pt.y > 624 || m_moucha == -1) {
		SetCursor(LoadCursor(NULL, IDC_ARROW));
		return TRUE;
	}
*/
	if (GetIndex() == -1 || m_moucha == -1 || m_sounding == true)
		SetCursor(LoadCursor(NULL, IDC_ARROW));
	else
		if (m_lbd) SetCursor(m_hCurP);
		else SetCursor(m_hCurS);

	
//	return CDialog::OnSetCursor(pWnd, nHitTest, message);
	return TRUE;
}

int CTestDlg2Dlg::GetIndex()
{
	CPoint pt = m_mouse;

	if (pt.x < 56 || pt.y < 101 || pt.x > 513 || pt.y > 570)
		return -1;

	pt.x -= 56;
	pt.y -= 101;

	if (pt.x % 77 > 64 || pt.y % 80> 64) return -1;


	pt.x /= 77;
	pt.y /= 80;

	return pt.x + pt.y*6;
}

void CTestDlg2Dlg::OnOK() 
{
}

void CTestDlg2Dlg::OnStart() 
{
	m_tim = 0;

	m_moucha = -1;
	if (SZVUK & m_zvuk) PlaySound("WAV_TRALALA", AfxGetApp()->m_hInstance, SND_SYNC|SND_RESOURCE);
	if (STEXT & m_zvuk) MessageBox("Tralalal");
	m_moucha = rand()%36;
	SetToFly();
	m_hits = 0;
	OnSetCursor(NULL, 0, 0);
}	

void CTestDlg2Dlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDblClk(nFlags, point);

	m_tim = 0;

	if (m_moucha == -1 || m_sounding == true) return;

	int in = GetIndex();
	if (in == -1) return;

	m_hits++;


	if (SZVUK & m_zvuk) {
		m_sounding = true;
		AfxBeginThread(G_DBLCLKFunction, this);
	}
	else {
		if (in == m_moucha) {
			m_moucha = -1;
			if (m_hits == 0) 
				MessageBox("Mas stesti, dostal jsi m. Sbohem.");
			else 
				MessageBox("Au, dostal jsi m. Sbohem.");
			return;
		}
	
	
		int dx = abs(in%6 - m_moucha%6);
		int dy = abs(in/6 - m_moucha/6);

		if (dx + dy == 1) MessageBox("Hej! To bylo ale blzko!");
		else
			if (dx == 1 && dy == 1) 
				MessageBox("Cha cha, nezashl jsi m!");
			else 
				MessageBox("Netrefil ses.");

		if (--m_tofly <= 0) {
			MessageBox("Bzzzz. Prv letm pri.");
			m_moucha = rand()%36;
			SetToFly();
		}
	}

}

void CTestDlg2Dlg::OnAbout() 
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void CTestDlg2Dlg::SetToFly()
{
	m_tofly = rand()%7+1;
}

void CTestDlg2Dlg::OnClose() 
{
	AfxGetApp()->WriteProfileInt("Nastaveni", "zvuk", m_zvuk);
	
	CDialog::OnClose();
}

void CTestDlg2Dlg::OnNastaveniText() 
{
	m_zvuk = STEXT;	
	OnUpdate(NULL);
}

void CTestDlg2Dlg::OnNastaveniZvuk() 
{
	m_zvuk = SZVUK;	
	OnUpdate(NULL);
}

void CTestDlg2Dlg::OnUpdate(CCmdUI* pCmdUI) 
{
	CMenu *m = GetMenu();
	if (m_zvuk == SZVUK) m->CheckMenuItem(ID_NASTAVENI_ZVUK ,MF_BYCOMMAND | MF_CHECKED);
	else m->CheckMenuItem(ID_NASTAVENI_ZVUK ,MF_BYCOMMAND | MF_UNCHECKED);
	if (m_zvuk == STEXT) m->CheckMenuItem(ID_NASTAVENI_TEXT ,MF_BYCOMMAND | MF_CHECKED);
	else m->CheckMenuItem(ID_NASTAVENI_TEXT ,MF_BYCOMMAND | MF_UNCHECKED);
}

void CTestDlg2Dlg::OnTimer(UINT nIDEvent) 
{
	if (rand()%2 && m_tim != 0 && m_moucha != -1 && m_sounding == false)
		if (SZVUK & m_zvuk) PlaySound("WAV_CHICHI", AfxGetApp()->m_hInstance, SND_ASYNC|SND_RESOURCE);

	m_tim++;
	
	CDialog::OnTimer(nIDEvent);
}
